'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _clkfreq = $4E495053 ' SPIN

  NEW_LINE = 10
  eeprom_pin = 28
  sdcard_pin = 16

OBJ
  c : "clib_os"
  sys : "sysdefs"

DAT
  badflag long 0
  buffer byte 0[100]
  version byte "\nspinix 0.57 March 19, 2012\n", 0
  argv long 0[20]
  strbuf byte 0[50]
  strptr long 0
  aliasbuf byte 0[200]
  aliasbptr long 0
  aliasptr word 0[20]
  aliasnum long 0
  runmode long 0

DAT
  redirectin long 0
  redirectout long 0
  scriptfile long 0
  scriptline long 0
  scriptname long 0[20]
  CouldNotOpen byte "Could not open %s\n", 0
  RedirectionError byte "Redirection error\n", 0

PUB main(argc, i) | pathstr[20], histfile
  if argc > 1
    if c.remove(string("/__reboot")) => 0
      'c.printf0(string("Starting up from reboot\n"))
      c.strcpy(@scriptname, string("/_restart"))
      scriptfile := c.fopen(@scriptname, string("r"))
    ifnot scriptfile
      c.printf0(@version)
      c.strcpy(@scriptname, string("/_startup"))
      scriptfile := c.fopen(@scriptname, string("r"))
  else
    c.strcpy(@scriptname, string("/_restart"))
    scriptfile := c.fopen(@scriptname, string("r"))

  strptr := @strbuf
  aliasbptr := @aliasbuf

  'c.printf0(string("Trace 1\n"))

  REPEAT
    ' Close redirection files if opened
    if redirectin
      c.resetstdin
      c.fclose(redirectin)
      redirectin := 0
    if redirectout
      c.resetstdout
      c.fclose(redirectout)
      redirectout := 0

    if scriptfile
      if c.fgets(@buffer, 100, scriptfile) =< 0
        c.fclose(scriptfile)
        scriptfile := 0
        next
      scriptline++
      i := strsize(@buffer) - 1
      if i => 0 AND byte[@buffer][i] == 10
        byte[@buffer][i] := 0

    else
      c.getcwd(@buffer, 100)
      c.printf1(STRING("\n%s$ "), @buffer)
      c.gets(@buffer)
      if CheckBang
        next
                                              
    if byte[@buffer] == "#"
      next

    CheckAlias
    argc := tokenize(@buffer, @argv)
    argc := Redirection(argc)

    'c.printf2(string("argc = %d, argv[0] = %s\n"), argc, argv[0])

    ifnot argc
      next

    if strcomp(argv[0], string("alias"))
      AliasCommand(argc)
      next

    if strcomp(argv[0], string("set"))
      PrintAlias(c.getstdout)
      next

    if strcomp(argv[0], string("history"))
      histfile := c.fopen(string("/_history"), string("r"))
      ifnot histfile
        next
      i := 1
      repeat while c.fgets(@buffer, 100, histfile)
        c.printf2(string("%3d %s"), i++, @buffer)
      c.fclose(histfile)
      next

    ifnot (i := FindExecTarget(argv[0], @pathstr))
      next

    if i == 1
      if scriptfile
        c.fclose(scriptfile)
      scriptfile := c.fopen(@pathstr, string("r"))
      scriptline := 0
      c.strcpy(@scriptname, @pathstr)
      ifnot scriptfile
        c.printf1(@CouldNotOpen, @pathstr)
      else
        if argc > 1
          c.sscanf1(argv[1], string("%d"), @scriptline)
          repeat scriptline
            if c.fgets(@buffer, 100, scriptfile) =< 0
              quit
    elseif i := run(@pathstr, argc, @argv, runmode)
      if i == -2
        c.printf1(string("Not enough memory to run %s\n"), @pathstr)
      else
        c.printf1(@CouldNotOpen, @pathstr)

PUB CheckBang | num, i, histfile, ptr
  ptr := SkipChar(@buffer, " ")
  ifnot byte[ptr]
    return
  if buffer[0] == "!"
    if buffer[1] == "!"
      num := -1
    elseif c.isdigit(buffer[1])
      c.sscanf1(@buffer[1], string("%d"), @num)
    else
      num := -2
      c.strcpy(@strbuf, @buffer)
        
    histfile := c.fopen(string("/_history"), string("r"))
    i := 0
    if histfile
      repeat while c.fgets(@buffer, 100, histfile)
        i++
        if num == -2
          ifnot c.strncmp(@buffer, @strbuf, strsize(@strbuf))
            num := -3
            quit
        elseif i == num
          quit
      c.fclose(histfile)
    if i and ((num == -1) or (num == -3) or (num == i))
      c.printf2(string("%3d %s"), i, @buffer)
      num := strsize(@buffer)
      if num
        buffer[num-1] := 0
    else
      return 1

  histfile := c.fopen(string("/_history"), string("a"))
  if histfile
    c.fprintf1(histfile, string("%s\n"), @buffer)
    c.fclose(histfile)

PUB AliasCommand(argc)
  if argc == 2
    c.strcpy(aliasbptr, argv[1])
    aliasptr[aliasnum++] := aliasbptr
    aliasbptr += strsize(aliasbptr) + 1

PUB PrintAlias(outfile) | i
  if aliasnum
    repeat i from 0 to aliasnum-1
      c.fprintf1(outfile, string("alias \042%s\042\n"), aliasptr[i])

PUB CheckAlias | i, ptr, len1, len2, len3
  ifnot aliasnum
    return

  ptr := FindChar(@buffer, " ")
  if byte[ptr]
    len1 := strsize(ptr+1)
    byte[ptr] := 0
  else
    len1 := 0
  len2 := strsize(@buffer)

  repeat i from 0 to aliasnum-1
    ptr := FindChar(aliasptr[i], "=")
    if byte[ptr]
      byte[ptr] := 0
      if strcomp(aliasptr[i], @buffer)
        len3 := strsize(ptr+1)
        if len1 AND len2 <> len3
          bytemove(@buffer+len3+1, @buffer+len2+1, len1+1)
        bytemove(@buffer, ptr+1, len3+1)
        if len1
          byte[@buffer+len3] := " "
        byte[ptr] := "="
        'c.printf1(string("%s\n"), @buffer)
        return
      byte[ptr] := "="

  if len1
    byte[@buffer+len2] := " "

PUB FindExecTarget(fname, pathstr) | temp, infile, typestr[8]
  c.strcpy(pathstr, fname)
  repeat 2
    if (infile := c.fopen(pathstr, string("r")))
      quit
    temp := FindChar(pathstr, "/")
    if byte[temp]
      quit
    c.strcpy(pathstr, string("/bin/"))
    c.strcat(pathstr, fname)

  ifnot infile
    c.printf1(@CouldNotOpen, fname)
    return

  longfill(@typestr, 0, 8)
  c.fread(@typestr, 1, 32, infile)
  c.fclose(infile)

  if typestr == $4e495053 ' SPIN
    'c.printf0(string("Spin Program Detected\n"))
    result := 2
  elseif typestr == $50504143 ' CAPP
    'c.printf0(string("C App Detected\n"))
    runmode |= sys#run_c_program | cogid
    result := 4
  elseif typestr == 80_000_000
    if typestr[6] == $3710c735 and typestr[7] == $00322c0e
      'c.printf0(string("Stand-alone C Program Detected\n"))
      runmode := sys#run_c_program | sys#run_stand_alone | cogid
    elseifnot runmode
      'c.printf0(string("Stand-alone Spin Program Detected\n"))
      runmode := sys#run_at_address0 | sys#run_stand_alone | cogid
    result := 3
  elseifnot c.strncmp(@typestr, string("#shell"), 6)
    result := 1
  else
    c.printf1(string("%s is not an executable file\n"), fname)

PUB AddToCogTable(cognum, type, name, startaddr, size) | entryptr
  entryptr := sys#cogtable + (cognum * 24)
  byte[entryptr] := type
  bytemove(entryptr+1, name, 19)
  byte[entryptr+19] := 0
  word[entryptr+20] := startaddr
  word[entryptr+22] := size

PUB RemoveFromCogTable(cognum) | entryptr
  entryptr := sys#cogtable + (cognum * 24)
  byte[entryptr] := 0

PUB Redirection(argc) | i, argc1, ptr, char, mode
  runmode := sys#run_shell_wait
  if (argc < 2)
    return argc
  argc1 := 1
  repeat i from 1 to argc - 1
    ptr := argv[i]
    char := byte[ptr++]
    if char == "<"
      if (byte[ptr] == 0)
        ptr := argv[++i]
        if (i => argc)
          c.printf0(@RedirectionError)
          argc1 := 0
          quit
      redirectin := c.fopen(ptr, string("r"))
      ifnot redirectin
        c.printf1(@CouldNotOpen, ptr)
        argc1 := 0
        quit
      else
        c.setstdin(redirectin)
    elseif char == ">"
      if (byte[ptr] == ">")
        ptr++
        mode := string("a")
      else
        mode := string("w")
      if (byte[ptr] == 0)
        ptr := argv[++i]
        if (i => argc)
          c.printf0(@RedirectionError)
          argc1 := 0
          quit
      redirectout := c.fopen(ptr, mode)
      ifnot redirectout
        c.printf1(@CouldNotOpen, ptr)
        argc1 := 0
        quit
      else
        c.setstdout(redirectout)
    elseif char == "&"
      if byte[ptr] == "&"       ' Kill shell
        ptr++
        runmode := sys#run_kill_caller | cogid
      elseif byte[ptr] == "^"   ' Shell waits
        ptr++
      elseif byte[ptr] == "*"   ' Run stand-alone
        ptr++
        runmode := sys#run_stand_alone | cogid
      else                      ' Shell does not wait
        runmode := sys#run_shell_nowait
      if byte[ptr] == "0"       ' Run at location 0
        runmode |= sys#run_at_address0
      elseif byte[ptr] == "c"       ' Run C program at location 0
        runmode |= sys#run_c_program
    else
      argv[argc1++] := argv[i]
  return argc1

' This routine returns a pointer to the first character not
' matching the passed value
PUB SkipChar(str, value_0)
  REPEAT WHILE (BYTE[str])
    IF (BYTE[str] <> value_0)
      QUIT
    str++
  RETURN str
  
' This routine returns a pointer to the first charcter that
' matches the passed value
PUB FindChar(str, value_0)
  REPEAT WHILE (BYTE[str])
    IF (BYTE[str] == value_0)
      QUIT
    str++
  RETURN str
  
' This routine extracts tokens from the input string that
' are seperated by at least one space character
PUB tokenize(ptr, tokens) | num
  num := 0
  repeat
    ptr := SkipChar(ptr, " ")
    ifnot byte[ptr]
      quit
    num++
    if byte[ptr] == $22
      long[tokens] := ++ptr
      ptr := FindChar(ptr, $22)
    else
      long[tokens] := ptr
      ptr := FindChar(ptr, " ")
    tokens += 4
    IF (BYTE[ptr] == 0)
      QUIT
    BYTE[ptr++] := 0
  RETURN num

PUB run(fname, argc, pargv, mode) | cognum, entryptr, outfile
  'c.printf1(string("runmode = %2.2x\n"), runmode)
  mode |= cogid
  if mode & (sys#run_kill_caller | sys#run_stand_alone)
    if mode & sys#run_stand_alone
      outfile := c.fopen(string("/__reboot"), string("w"))
      if outfile
        c.fclose(outfile)
    outfile := c.fopen(string("/_restart"), string("w"))
    if outfile
      'if mode & $08
      '  c.fprintf0(outfile, string("#standalone\n"))
      PrintAlias(outfile)
      c.getcwd(strptr, 50)
      c.fprintf1(outfile, string("cd %s\n"), strptr)
      if scriptfile
        c.fprintf2(outfile, string("%s %d\n"), @scriptname, scriptline)
      c.fclose(outfile)
  long[pargv] := fname
  if mode & sys#run_c_program
    'c.printf0(string("shell: calling runc\n"))
    cognum := c.runc(argc, pargv, mode)
  else
    cognum := c.run(argc, pargv, mode)
  if cognum < 0
    return cognum
  entryptr := sys#cogtable + (cognum * 24)
  ifnot (mode & sys#run_shell_nowait)
    repeat while byte[entryptr]

{
PUB CheckMallocSpace | ptr, numalloc, numfree
  numalloc := 0
  numfree := 0
  ptr := long[sys#malloclist]
  c.printf0(string("MallocList\n"))
  repeat while(ptr)
    c.printf2(string("addr = %04x size = %d\n"), ptr, word[ptr][1])
    numalloc += word[ptr][1]
    ptr := word[ptr]
  ptr := long[sys#memfreelist]
  c.printf0(string("FreeList\n"))
  repeat while(ptr)
    c.printf2(string("addr = %04x size = %d\n"), ptr, word[ptr][1])
    numfree += word[ptr][1]
    ptr := word[ptr]
  c.printf2(string("%d bytes allocated, %d bytes free\n"), numalloc, numfree)
}    

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
